//+------------------------------------------------------------------+
//|                                                NonLagMA_v7.1.mq4 |
//|                                Copyright  2007, TrendLaboratory |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, TrendLaboratory"
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"


#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Orange
#property indicator_width1 2
#property indicator_color2 SkyBlue
#property indicator_width2 2
#property indicator_color3 Tomato
#property indicator_width3 2


//---- input parameters
extern int     swingCount     = 5;
extern double  speed          = 0.3;
extern int     Price          = 0;  //Apply to Price(0-Close;1-Open;2-High;3-Low;4-Median price;5-Typical price;6-Weighted Close) 
extern double  PctFilter      = 1.3;  //Dynamic filter in decimal

extern int     Displace       = 0;  //DispLace or Shift 
extern int     Color          = 1;  //Switch of Color mode (1-color)  
extern int     ColorBarBack   = 0;  //Bar back for color mode
extern double  Deviation      = 0;  //Up/down deviation        
extern bool    arrowsVisible    = true;

 int     AlertMode      = 0;  //Sound Alert switch (0-off,1-on) 
 int     WarningMode    = 0;  //Sound Warning switch(0-off,1-on) 
//---- indicator buffers
double MABuffer[];
double UpBuffer[];
double DnBuffer[];
double trend[];
double Del[];
double AvgDel[];
double swingBuffer[];

 string arrowsIdentifier = "albNonlagMAarrows";
 color  arrowsUpColor    = PowderBlue;
 color  arrowsDnColor    = DeepPink;
 double ArrowUpCode =233;
 double ArrowDnCode =234;

double alfa[];
int i, Phase, Len,Cycle=4;
double Coeff, beta, t, Sum, Weight, g;
double pi = 3.1415926535;    
bool   UpTrendAlert=false, DownTrendAlert=false;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init(){
   IndicatorBuffers(7);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,MABuffer);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,UpBuffer);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,DnBuffer);
   SetIndexBuffer(3,trend);
   SetIndexBuffer(4,Del);
   SetIndexBuffer(5,AvgDel); 
   SetIndexBuffer(6,swingBuffer); 
   string short_name;
//---- indicator line
   
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
//---- name for DataWindow and indicator subwindow label
   short_name="alb NonLagMA("+swingCount+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"NonLagMA");
   SetIndexLabel(1,"Up");
   SetIndexLabel(2,"Dn");
//----
   SetIndexShift(0,Displace);
   SetIndexShift(1,Displace);
   SetIndexShift(2,Displace);
   
   SetIndexEmptyValue(0,EMPTY_VALUE);
   SetIndexEmptyValue(1,EMPTY_VALUE);
   SetIndexEmptyValue(2,EMPTY_VALUE);

   return(0);
}

int deinit(){
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--){
      string objectName = ObjectName(i);
      if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return(0);
}
//+------------------------------------------------------------------+
//| NonLagMA_v7.1                                                    |
//+------------------------------------------------------------------+
int start(){
   int i,k,n,shift, counted_bars=IndicatorCounted(),limit;
   int Length=-1;
   double price;      
   if ( counted_bars > 0 )  limit=Bars-counted_bars;
   if ( counted_bars < 0 )  return(0);
   if ( counted_bars ==0 )  limit=Bars-Len-1; 
  
   for(shift=limit;shift>=0;shift--) {	
      int swing = 0;
      if (High[shift]>High[shift+1] && High[shift+1]>High[shift+2] && Low[shift+2] < Low[shift+3] && Low[shift+3] < Low[shift+4]) swing = -1;
      if (Low[shift] < Low[shift+1] && Low[shift+1] < Low[shift+2] && High[shift+2]>High[shift+3] && High[shift+3]>High[shift+4]) swing =  1;
      swingBuffer[shift] = swing;
      for (k=shift,n=0; (k<Bars) && (n<swingCount); k++) if(swingBuffer[k]!=0) n++;
      int tempLen = MathMax(MathRound((k-shift)/swingCount/speed),3);
      if (tempLen!=Length) {
         Length = tempLen;
         Coeff =  3*pi;
         Phase = Length-1;
         Len   = Length*4 + Phase;  
         ArrayResize(alfa,Len);
         Weight=0;    
         for (i=0;i<=Len-1;i++){
            if (i<=Phase-1) t = 1.0*i/(Phase-1);
            else  t = 1.0 + (i-Phase+1)*(2.0*Cycle-1.0)/(Cycle*Length-1.0); 
            beta = MathCos(pi*t);
            g    = 1.0/(Coeff*t+1);   
            if (t <= 0.5 ) g = 1;
            alfa[i] = g * beta;
            Weight += alfa[i];
         }
      }
      if (Weight <=0) continue;
      Sum = 0;
      for (i=0;i<=Len-1;i++){ 
         price = iMA(NULL,0,1,0,3,Price,i+shift);      
         Sum += alfa[i]*price;
      }
	   if (Weight > 0) MABuffer[shift] = (1.0+Deviation/100)*Sum/Weight;
	   
//PCT Filter	   
      if (PctFilter>0){
         Del[shift] = MathAbs(MABuffer[shift] - MABuffer[shift+1]);
         double sumdel=0;
         for (i=0;i<=Length-1;i++) sumdel = sumdel+Del[shift+i];
         AvgDel[shift] = sumdel/Length;
         double sumpow = 0;
         for (i=0;i<=Length-1;i++) sumpow+=MathPow(Del[shift+i]-AvgDel[shift+i],2);
         double StdDev = MathSqrt(sumpow/Length); 
         double Filter = PctFilter * StdDev;
         if( MathAbs(MABuffer[shift]-MABuffer[shift+1]) < Filter ) MABuffer[shift]=MABuffer[shift+1];
      }
      else Filter=0;
      
      trend[shift]=trend[shift+1];
      if (MABuffer[shift]-MABuffer[shift+1] > Filter) trend[shift]= 1; 
      if (MABuffer[shift+1]-MABuffer[shift] > Filter) trend[shift]=-1; 
      
      if (arrowsVisible && trend[shift]!=trend[shift+1]) manageArrow(shift,trend[shift]); 

//Color      
      if (Color>0){
         if (trend[shift]>0){  
            UpBuffer[shift] = MABuffer[shift];
            if (trend[shift+ColorBarBack]<0) UpBuffer[shift+ColorBarBack]=MABuffer[shift+ColorBarBack];
            DnBuffer[shift] = EMPTY_VALUE;
            if (WarningMode>0 && trend[shift+1]<0 && shift==0) PlaySound("alert2.wav");
         }
         if (trend[shift]<0){
            DnBuffer[shift] = MABuffer[shift];
            if (trend[shift+ColorBarBack]>0) DnBuffer[shift+ColorBarBack]=MABuffer[shift+ColorBarBack];
            UpBuffer[shift] = EMPTY_VALUE;
            if (WarningMode>0 && trend[shift+1]>0 && shift==0) PlaySound("alert2.wav");
         }
      }
   }

//Alerts  
   string Message;
   if ( trend[2]<0 && trend[1]>0 && Volume[0]>1 && !UpTrendAlert){
      Message = " "+Symbol()+" M"+Period()+": Signal for BUY";
	   if ( AlertMode>0 ) Alert (Message); 
	   UpTrendAlert=true; DownTrendAlert=false;
   } 
	 	  
   if ( trend[2]>0 && trend[1]<0 && Volume[0]>1 && !DownTrendAlert){
	   Message = " "+Symbol()+" M"+Period()+": Signal for SELL";
	   if ( AlertMode>0 ) Alert (Message); 
	   DownTrendAlert=true; UpTrendAlert=false;
   } 	         
   return(0);	
}

//+------------------------------------------------------------------+
//| Subfunctions
//+------------------------------------------------------------------+

//************************ arrow functions

void manageArrow(int i, int trendArr){
   if (arrowsVisible ){
      deleteArrow(Time[i]);
      if (trendArr == 1) drawArrow(i,arrowsUpColor,ArrowUpCode,false); 
      if (trendArr ==-1) drawArrow(i,arrowsDnColor,ArrowDnCode,true);
   }
}               

void drawArrow(int i,color theColor,int ArrowCode,bool up){
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = iATR(NULL,0,20,i);
   ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
   ObjectSet(name,OBJPROP_ARROWCODE,ArrowCode);
   ObjectSet(name,OBJPROP_COLOR,theColor);
   if (up)ObjectSet(name,OBJPROP_PRICE1,High[i]+gap);
   else   ObjectSet(name,OBJPROP_PRICE1,Low[i] -gap);
}

void deleteArrow(datetime time){
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}